#include "buttonnode.h"
#include "buttonshape.h"
#include "backgroundnode.h"

#include <iostream>

#include "scene/scenetree.h"
#include "input.h"
#include "sparrowshell/sparrowshell.h"
#include "mesh.h"
#include "phongmaterial.h"

ButtonNode::ButtonNode(glm::vec2 position,ButtonShape* shape):
    m_position(position),m_shape(shape)
{
}

void ButtonNode::setBackGround(BackGroundNode* background){
    m_background = background;
    addChild(background);
}

BackGroundNode* ButtonNode::getBackGround()
{
    return m_background;
}

void ButtonNode::update()
{
    Input* input = getEngine().getInput();
    sf::Vector2i v = input->getPosition();
    glm::vec2 pos = glm::vec2(v.x,v.y);
    if (m_shape->hover(pos)){
        PhongMaterial* mat = (PhongMaterial*) m_background->getGeometryNode()->mesh->getMaterial();
        mat->diffuse=glm::vec3(0.2,0.6,0.6);
    }else{
        PhongMaterial* mat = (PhongMaterial*) m_background->getGeometryNode()->mesh->getMaterial();
        mat->diffuse=glm::vec3(0.6,0.2,0.6);
    }

    for (auto action : input->getActions())
    {
        if (action == m_action){
            if (m_shape->hover(pos)){
                m_callback->exec();
//                getEngine().getShell()->out("hover");
            }
        }
    }
}
